#property copyright "Boss"
#property link      "Ustas"

#property indicator_separate_window
#property indicator_minimum -1.1
#property indicator_maximum 1.1
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Lime

extern int period = 25;
extern int limit = 5000;

extern bool   PopUp_Alerts = true;
extern bool   Email_Alerts = false;
extern bool   Mobile_Push_Alerts = false;

double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];

datetime alert_time;

int init() {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexBuffer(1, g_ibuf_92);
   SetIndexBuffer(2, g_ibuf_84);
   IndicatorShortName("BR16");
   return (0);
}

int start() {
   double ld_72;
   double ld_24 = 0;
   double ld_32 = 0;
   double ld_unused_40 = 0;
   double ld_unused_48 = 0;
   double ld_56 = 0;
   double ld_unused_64 = 0;
   double l_low_80 = 0;
   double l_high_88 = 0;
   for (int li_96 = 0; li_96 <= limit; li_96++) {
      g_ibuf_88[li_96] = 0;
      g_ibuf_92[li_96] = 0;
   }
   for (li_96 = 0; li_96 <= limit; li_96++) {
      l_high_88 = High[iHighest(NULL, 0, MODE_HIGH, period, li_96)];
      l_low_80 = Low[iLowest(NULL, 0, MODE_LOW, period, li_96)];
      ld_72 = (High[li_96] + Low[li_96]) / 2.0;
      if (l_high_88 != l_low_80) ld_24 = 0.66 * ((ld_72 - l_low_80) / (l_high_88 - l_low_80) - 0.5) + 0.67 * ld_32;
      else ld_24 = 0.0;
      ld_24 = MathMin(MathMax(ld_24, -0.999), 0.999);
      g_ibuf_84[li_96] = MathLog((ld_24 + 1.0) / (1 - ld_24)) / 2.0 + ld_56 / 2.0;
      ld_32 = ld_24;
      ld_56 = g_ibuf_84[li_96];
   }
   for (li_96 = 0; li_96 <= limit; li_96++) {
      if (g_ibuf_84[li_96] >= 0.0 && g_ibuf_84[li_96 + 1] < 0.0) g_ibuf_88[li_96] = -1;
      if (g_ibuf_84[li_96] <= 0.0 && g_ibuf_84[li_96 + 1] > 0.0) g_ibuf_92[li_96] = 1;
   }
   
   
   if (g_ibuf_92[0]!=EMPTY_VALUE && g_ibuf_92[0]!=0)
    {
     if (Time[0]>alert_time)
      {
       if (PopUp_Alerts)Alert(Symbol(), PeriodToStr(), "- BR16 DOWN Arrow");
       if (Email_Alerts)SendMail("BR16 Alert", Symbol() + PeriodToStr() + "- BR16 DOWN Arrow");
       if (Mobile_Push_Alerts)SendNotification(Symbol() + PeriodToStr() + "- BR16 DOWN Arrow");
       alert_time=Time[0];
      }
    }
   if (g_ibuf_88[0]!=EMPTY_VALUE && g_ibuf_88[0]!=0)
    {
     if (Time[0]>alert_time)
      {
       if (PopUp_Alerts)Alert(Symbol(), PeriodToStr(), "- BR16 UP Arrow");
       if (Email_Alerts)SendMail("BR16 Alert", Symbol() + PeriodToStr() + "- BR16 UP Arrow");
       if (Mobile_Push_Alerts)SendNotification(Symbol() + PeriodToStr() + "- BR16 UP Arrow");
       alert_time=Time[0];
      }
    }
    
   
   return (0);
}

string PeriodToStr()
 {
  switch(Period())
   {
    case 1:return(" M1 ");
    case 5:return(" M5 ");
    case 15:return(" M15 ");
    case 30:return(" M30 ");
    case 60:return(" H1 ");
    case 240:return(" H4 ");
    case 1440:return(" D1 ");
    case 10080:return(" W1 ");
    case 43200:return(" MN1 ");
    
    default:return(StringConcatenate(" ", Period()," "));
   }
 }